require 'date'
module DellinInfo
  module API
    class Order < BaseApi
      ATTRIBUTES = [
        :availableAD,
        :estimatedDeliveryDate,
        :terminalSender,
        :unvailableSfRequestReason,
        :isSfRequestOrdered,
        :availableSfRequest,
        :opf,
        :terminalReceiver,
        :docNumber,
        :comment,
        :sizedWeight,
        :ordNum,
        :sizedVolume,
        :docDate,
        :sqlUuid,
        :height,
        :width,
        :length,
        :aviaDeliveryType,
        :numAvia,
        :giveoutDate,
        :conditionAvia,
        :oversizedVolume,
        :oversizedWeight,
      ]
      
      attr_accessor :state, :city_sender, :city_receiver, *ATTRIBUTES

      def to_s
        estimated_delivery_date = Time.new(@estimatedDeliveryDate).strftime('%Y-%m-%d')
        year = Time.new(@estimatedDeliveryDate).strftime('%Y')
        estimated_delivery_date.clear unless year == Time.now().strftime('%Y')
        "накладная № #{@docNumber} от #{Date.parse docDate}\nОтправление из города #{@city_sender} в город #{@city_receiver}\nПредположительная дата прихода: #{estimated_delivery_date}\nстатус: #{@state}\n#{'-'*10}\n"
                                   
      end                           






      private
      def initialize(hash_track)
        data = parse_hash_response(hash_track, 'order')

        ATTRIBUTES.each do |attribute|

          self.send(set_attr_method(attribute), data[attribute])

        end

        @state = 'не установлен'
        
      end
      
      
    end
  end
end



