require 'byebug'
require_relative 'order.rb'
module DellinInfo
  module API
    class OrderCollection < BaseApi
      include Enumerable

      config['partial_url'] = 'public/tracker_advanced'


      attr_reader :errors, :orders, :cash

      def each 
        @orders.each {|oder| yield oder} 
        
      end



      private
      def initialize(orders_hash)
        @errors = orders_hash['errormsg']
        @orders = []
        @cash = orders_hash.dig('orders', 'tracker') unless orders_hash['orders'].blank?

        unless @cash.nil?
          @cash.each do |track|
            @orders << Order.new(track)
          end  
        end

        determine_state!

      end

      def determine_state!

        @orders.each do |order|
          id_oder = order.docNumber
          status = DellinInfo::API.status_oder(id_oder)
          order.state = status.state
          order.city_sender = status.receive['city']
          order.city_receiver = status.giveout['city']
        end

        self
        
      end


      
      
    end
  end
end
